package org.jboss.byteman.rule.helper;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;

import org.junit.Test;

public class HelperTest {
	@Test
    public void join()
    {
		String key = "KEY";
        Helper helper = new Helper(null);
        Thread t1 = new TestThread(helper, key);
        Thread t2 = new TestThread(helper, key);
    	helper.createJoin(key, 2);
    	t1.start();
    	t2.start();
    	assertTrue(helper.isJoin(key, 2));
		helper.joinWait(key, 2);
    	assertFalse(helper.isJoin(key, 2));
    }

	
	class TestThread extends Thread{
		Helper helper;
		String key;
		public TestThread(Helper helper, String key){
			this.helper = helper;
			this.key = key;
		}
		@Override
		public void run() {
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
			}
			helper.joinEnlist(key);
		}
	}
}
